// +-------------------------------------------+
// |  ___   _     _____   __  __  ____   ____  |
// | | __| | |   | /_\ |  \ \/ / | ___| | /\ | |
// | |__ | | |_  |  _  |   \  /  | __|  | \/ / |
// | |___| |___| |_| |_|   |__|  |____| |_| \\ |
// |  Greek2me              Blockland ID 11902 |
// +-----------------------------+-------------+
// | DO NOT EDIT BELOW THIS LINE |
// +-----------------------------+

if(!$Slayer::Server::Dependencies::Gamemodes)
	exec("Add-ons/Gamemode_Slayer/Dependencies/Gamemodes.cs");
Slayer.Gamemodes.addMode("Search & Destroy","SD",1,1); //add the gamemode (uiName,fName,useTeams,useRounds)

//register preferences (category,title,variable,control type,default,requires reset,notify,editRights,list,callback)
if(!$Slayer::Server::Dependencies::Preferences)
	exec("Add-ons/Gamemode_Slayer/Dependencies/Preferences.cs");
Slayer.Prefs.addPref("Search & Destroy","Pick Random Defending Team","%mini.SD_randomDefense","bool",1,0,1,-1,"Rules SD Mode");
Slayer.Prefs.addPref("Search & Destroy","Bomb Hold Time","%mini.SD_bombHoldTime","int 0 10",2,0,1,-1,"Rules SD Mode");
Slayer.Prefs.addPref("Search & Destroy","Bomb Max Ticks","%mini.SD_maxBombTicks","slide 0 66 65 1",50,0,1,-1,"Rules SD Mode");
Slayer.Prefs.addPref("Search & Destroy","Win on Defuse","%mini.SD_winOnDefuse","bool",0,0,1,-1,"Rules SD Mode");
Slayer.Prefs.addPref("Search & Destroy","Bomb Defuse","%mini.SD_points_defuse","int -999 999",10,0,0,-1,"Rules SD Points");
Slayer.Prefs.addPref("Search & Destroy","Bomb Plant","%mini.SD_points_plant","int -999 999",10,0,0,-1,"Rules SD Points");

// +------------+
// | Datablocks |
// +------------+
datablock TriggerData(SlyrSDTriggerData)
{
	tickPeriodMS = 500;
};

datablock fxDTSbrickData(brickSD_BombData : brick8x8FData)
{
	uiName = "Bomb";
	category = "Slayer";
	subCategory = "Search & Destroy";

	indestructable = 1;

	isSlyrBrick = 1;
	slyrType = "SD_Bomb";

	setOnceOnly = 1;
};

datablock fxDTSbrickData(brickSD_AttSpawnPointData : brickSpawnPointData)
{
	uiName = "Attacker Spawn Point";
	category = "Slayer";
	subCategory = "Search & Destroy";

	indestructable = 1;

	isSlyrBrick = 1;
	slyrType = "SD_AttSpawn";

	setOnceOnly = 1;
};

datablock fxDTSbrickData(brickSD_DefSpawnPointData : brickSpawnPointData)
{
	uiName = "Defender Spawn Point";
	category = "Slayer";
	subCategory = "Search & Destroy";

	indestructable = 1;

	isSlyrBrick = 1;
	slyrType = "SD_DefSpawn";

	setOnceOnly = 1;
};

function SlyrSDTriggerData::onTickTrigger(%this,%trigger,%player)
{
	if(%player.getClassName() !$= "Player")
		return;

	%client = %player.client;
	if(!isObject(%client))
		return;

	%mini = getMinigameFromObject(%client);
	if(!isSlayerMinigame(%mini))
		return;
	if(%mini.mode !$= "SD")
		return;
	if(%mini.isResetting())
		return;
	if(!minigameCanUse(%mini,%this))
		return;

	Slayer_Support::Debug(2,"SD Bomb Tick",%this TAB %trigger TAB %mini TAB %player TAB %client);

	%maxTicks = %mini.SD_maxBombTicks;
	%brick = %trigger.brick;
	%team = %client.getTeam();
	%dTeam = %mini.SD_dTeam;
	%attCol = %team.color;
	%defCol = %brick.getColorID();

	if(%attCol != %defCol && (%team == %dTeam || (%team != %dTeam && %defCol == %dTeam.color)))
	{
		if(%brick.capture[%attCol] < %maxTicks)
		{
			%brick.capture[%attCol] ++;
			for(%i=0; %i < %brick.capture[%attCol]; %i++)
				%a = "_" @ %a;
			for(%i=0; %i < %maxTicks-%brick.capture[%attCol]; %i++)
				%d = "_" @ %d;

			%rgb = getColorIDTable(%defCol);
			%hex = "<color:" @ Slayer_Support::RgbToHex(%rgb) @ ">";

			%client.bottomPrint("<just:center>" @ %team.getColorHex() @ %a @ %hex @ %d,1);
		}
		else
		{
			%brick.setBombControl(%attCol,0,%client);

			if(%team == %dTeam)
				%client.bottomPrint("<just:center>\c5The bomb has not been planted yet. Defend it!",1);
			else
				%client.bottomPrint("<just:center>\c5The bomb has been planted. Defend it until it explodes!",1);
		}
	}
	else
	{
		if(%team == %dTeam)
			%client.bottomPrint("<just:center>\c5The bomb has not been planted yet. Defend it!",1);
		else
			%client.bottomPrint("<just:center>\c5The bomb has been planted. Defend it until it explodes!",1);
	}
}

function fxDtsBrick::setBombControl(%this,%color,%reset,%client)
{
	if(%this.getDatablock() != brickSD_BombData.getID())
		return;

	%mini = getMinigameFromObject(%this);
	if(!isSlayerMinigame(%mini) || %mini.mode !$= "SD")
		return;

	%dTeam = %mini.SD_dTeam;
	%team = %client.getTeam();

	%oldColor = %this.getColorID();
	%this.setColor(%color);

	for(%i=0; %i < 64; %i++)
		%this.capture[%i] = "";

	if(isObject(%client) && !%reset)
	{
		if(%team == %dTeam)
		{
			for(%i=0; %i < 64; %i++)
			{
				cancel(%mini.SD_Timer[%i]);
				%mini.SD_Timer[%i] = "";
			}

			%client.incScore(%mini.SD_points_defuse);

			%mini.messageAll('',%team.getColorHex() @ %client.getPlayerName() SPC "\c5managed to defuse the bomb for" SPC %dTeam.getColoredName() @ ".");
			%mini.bottomPrintAll(%team.getColorHex() @ %client.getPlayerName() SPC "\c5managed to defuse the bomb for" SPC %dTeam.getColoredName() @ ".",3);

			if(%mini.SD_winOnDefuse)
			{
				%mini.endRound(%team);
				return;
			}
		}
		else
		{
			%client.incScore(%mini.SD_points_plant);

			%mini.messageAll('',%team.getColorHex() @ %client.getPlayerName() SPC "<color:ff00ff>managed to plant the bomb for" SPC %mini.Teams.getTeamsFromColor(%dTeam.color,"COM",1,1) @ ".");

			Slayer_SD_winTick(%mini,%color,0);
		}
	}

	//onCapture Input Event
	$InputTarget_["Self"] = %this;
	$InputTarget_["Player"] = %client.player;
	$InputTarget_["Client"] = %client;
	if(isObject(%mini))
		$InputTarget_["MiniGame"] = %mini;
	else
		$InputTarget_["MiniGame"] = 0;

	if(%reset)
	{
		%this.processInputEvent("onCPReset",%client);
	}
	else
	{
		%this.processInputEvent("onCPCapture",%client);

		for(%i=0; %i < %mini.Teams.getCount(); %i++)
		{
			%t = %mini.Teams.getObject(%i);
			if(%t.color == %color)
				%this.processInputEvent("onCPCapture(Team" @ %i + 1 @ ")",%client);
		}
	}
}

function Slayer_SD_onRules(%mini,%client)
{
	messageClient(%client,'',"\c5 + The defending team must prevent the bomb from detonating. The attackers must plant and detonate the bomb.");
	if(isObject(%mini.SD_dTeam))
		messageClient(%client,'',"\c5 + The defending team is now" SPC %mini.SD_dTeam.getColoredName() @ "\c5.");
	else
		Slayer_Support::Error("Search & Destroy","Missing dTeam!");
}

function Slayer_SD_pickSpawnPoint(%mini,%client)
{
	%team = %client.getTeam();
	%dTeam = %mini.SD_dTeam;
	%aCount = 0;
	%dCount = 0;

	for(%i=0; %i < Slayer.Spawns.getCount(); %i++)
	{
		%br = Slayer.Spawns.getObject(%i);
		%type = %br.getDatablock().slyrType;
		%col = %br.getColorID();

		switch$(%type)
		{
			case SD_AttSpawn:
				%aSpawn[%aCount] = %br;
				%aCount ++;

			case SD_DefSpawn:
				%dSpawn[%dCount] = %br;
				%dCount ++;

			case TeamSpawn:
				if(%col == %team.color && %team != %dTeam) //the client's team has a spawn planted and is not the dTeam
					return 0;	
		}
	}

	if(%team == %dTeam)
	{
		%r = getRandom(0,%dCount-1);
		
		%spawn = %dSpawn[%r];
	}
	else
	{
		%r = getRandom(0,%aCount-1);
		%spawn = %aSpawn[%r];
	}

	return %spawn;
}

function Slayer_SD_preReset(%mini,%client)
{
	if(%mini.SD_randomDefense)
	{
		if(%mini.SD_dList $= "") //dList generation
		{
			for(%i=0; %i < %mini.Teams.getCount(); %i++)
				%mini.SD_dList = setField(%mini.SD_dList,%i,%mini.Teams.getObject(%i));
		}

		%r = getRandom(0,getFieldCount(%mini.SD_dList)-1);
		%t = getField(%mini.SD_dList,%r);

		%mini.SD_dList = removeField(%mini.SD_dList,%r);
		%mini.SD_dTeam = %t;
	}
	else
	{
		//use the first team
		if(%mini.Teams.getCount() > 0)
			%mini.SD_dTeam = %mini.Teams.getObject(0);
	}

	if(!isObject(%mini.SD_dTeam))
		Slayer_Support::Error("Search & Destroy","Missing dTeam!");

	%bomb = %mini.SD_bomb;
	if(isObject(%bomb))
	{
		for(%i=0; %i < 64; %i++)
			%bomb.capture[%i] = "";

		%bomb.origColor = %t.color;

		%bomb.setColor(%bomb.origColor);
	}
	else
		Slayer_Support::Error("Search & Destroy","Missing bomb!");

	for(%i=0; %i < 64; %i++)
	{
		cancel(%mini.SD_Timer[%i]);
		%mini.SD_Timer[%i] = "";
	}
}

function Slayer_SD_onModeEnd(%mini)
{
	for(%i=0; %i < 64; %i++)
	{
		cancel(%mini.SD_Timer[%i]);
		%mini.SD_Timer[%i] = "";
	}
}

function Slayer_SD_onSlyrBrickAdd(%mini,%brick,%type)
{
	switch$(%type)
	{
		case SD_Bomb:
			if(isObject(%mini.SD_bomb))
			{
				%brick.schedule(30,delete);
				return "\c5You may only have 1 bomb at a time.";
			}

			%brick.createTrigger(SlyrSDTriggerData);
			%brick.origColor = %mini.SD_dTeam.color;

			%mini.SD_bomb = %brick;

		case SD_AttSpawn:
			Slayer.Spawns.add(%brick);

		case SD_DefSpawn:
			Slayer.Spawns.add(%brick);
	}

	return 0;
}

function Slayer_SD_onSlyrBrickRemove(%mini,%brick,%type)
{
	switch$(%type)
	{
		case SD_Bomb:
			if(isObject(%brick.trigger))
				%brick.trigger.delete();

			if(%mini.SD_bomb == %brick)
				%mini.SD_bomb = "";
	}
}

function Slayer_SD_Teams_onAdd(%mini,%teamHandler,%team)
{
	if(%mini.SD_dList !$= "")
		%mini.SD_dList = setField(%sd.dList,getFieldCount(%sd.dList),%team);
}

function Slayer_SD_Teams_onRemove(%mini,%teamHandler,%team)
{
	%cnt = getFieldCount(%mini.SD_dList);
	for(%i=0; %i < %cnt; %i++)
	{
		%f = getField(%mini.SD_dList,%i);
		if(%f == %mini.Teams.team[%team])
		{
			%mini.SD_dList = removeField(%mini.SD_dList,%i);
			break;
		}
	}
}

function Slayer_SD_winTick(%mini,%color,%ticks)
{
	%time = %mini.SD_bombHoldTime;
	%dTeam = %mini.SD_dTeam;

	cancel(%mini.SD_Timer[%color]);

	Slayer_Support::Debug("Search & Destroy","winTick" SPC %color @ ":" SPC %ticks @ "/" @ %time);

	if(%ticks >= %time)
	{
		%mini.SD_Timer[%color] = "";
		%teamList = %mini.Teams.getTeamsFromColor(%color,"COM",1);

		if(isObject(tankShellExplosion))
			%mini.SD_bomb.spawnExplosion(tankShellProjectile,5);

		for(%i=0; %i < %mini.Teams.getCount(); %i++)
		{
			%t = %mini.Teams.getObject(%i);
			if(%dTeam == %t)
				%t.bottomPrintAll("<just:center><color:ff00ff>" @ %teamList SPC "successfully detonated the bomb. You have been defeated.");
			else
				%t.bottomPrintAll("<just:center><color:ff00ff>" @ %teamList SPC "managed to detonate the bomb. You have won.");
		}

		%teams = %mini.Teams.getTeamsFromColor(%color,"TAB");
		%mini.endRound(%teams);
	}
	else
	{
		%mini.bottomPrintAll("<just:center>\c3" @ %time-%ticks SPC (%time-%ticks == 1 ? "\c5minute remains" : "\c5minutes remain") SPC "before the bomb will explode.");

		if(%time-%ticks <= 5)
			%mini.messageAll('',"\c3" @ %time-%ticks SPC (%time-%ticks == 1 ? "\c5minute remains" : "\c5minutes remain") SPC "before the bomb will explode.");

		%mini.SD_Timer[%color] = schedule(60000,0,Slayer_SD_winTick,%mini,%color,%ticks++);
	}
}